program RegExpTestProject;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Classes,
  RegExp,
  RegExpObj in 'RegExpObj.pas';

var
  S: TStringList;

procedure TestRegExp(const Pattern, FileName: string);
var
  I, J: Integer;
  R: HRegExp;
  Error: Integer;
  ErrorBuf: string;
  Match: TRegMatch;
  UL: string;
begin
  R := RegComp(Pattern, Error);
  if Error <> 0 then
  begin
    RegError(R, Error, ErrorBuf);
    Writeln(ErrorBuf);
    Exit;
  end;
  try
    S := TStringList.Create;
    try
      S.LoadFromFile(FileName);
      for I := 0 to S.Count - 1 do
      begin
        FillChar(Match, SizeOf(Match), 0);
        Error := RegExec(R, S[I], Match);
        if Error = RE_OK then
        begin
          Writeln(I + 1:4, ' ', S[I]);
          Writeln(StringOfChar(' ', Match.Start + 5),
                  StringOfChar('-', Match.Stop - Match.Start));
        end;
      end;
    finally
      S.Free;
    end;
  finally
    RegFree(R);
  end;
end;

begin
  //example command line:
  //  regexptestproject reg.*code regexp.c
  TestRegExp(ParamStr(1), ParamStr(2));
  Readln;
end.
